final int    refresh=8,
             maxLivello=20,
             dimR=32,  dimC=32,     
             numR=16,  numC=20,
             EST=0, NORD=1, OVEST=2, SUD=3,
             iMURO=4, iGHIAIA=5, iBOMBA=6, iBOMBA_=7, iARRIVO=8,
             numOGGETTI=9;
final char   charIMMAGINI[] ={ 'e'     , 'e'     , 'e'     , 'e'      , 'M'   , ' '     , 'b'    , 'B'     , 'a'      };
final String nomiIMMAGINI[] ={ "eroeDx", "eroeSu", "eroeSx", "eroeGiù", "muro", "ghiaia", "bomba", "bomba_", "arrivo" };
final int    numIMMAGINI[]  ={ refresh , refresh , refresh , refresh  , 1     , 1       , refresh, refresh , refresh  };
final String nomiCATEGORIE[]={ "itis", "sokoban" };

int     RIGHE[]     =new int[numR];
int     COLONNE[]   =new int[numC];
char    livello[][] =new char[numR][numC];   
Bomba   leBOMBE[][] =new Bomba[numR][numC];
PImage  immagini[][]=new PImage[numOGGETTI][refresh];
Muro    muro        =new Muro();
Ghiaia  ghiaia      =new Ghiaia();
Arrivo  arrivo      =new Arrivo();
Eroe    eroe;
int     numLivello,
        numCategoria;

void setup()
{
  size(640, 640);
  frameRate(refresh);

  for(int r=0; r < numR; r++)
    RIGHE[r]  =r*dimR;
  for(int c=0; c < numC; c++) 
    COLONNE[c]=c*dimC;

  for(int i=0; i < numOGGETTI    ; i++)
  for(int j=0; j < numIMMAGINI[i]; j++)
    immagini[i][j]=loadImage(nomiIMMAGINI[i] + j + ".gif");

  numCategoria=0;
  numLivello=1;
  caricaLivello();
}

void draw() 
{ 
  aggiornaLivello(); 
}

void keyPressed()
{
  int tasto=keyCode; 

  if(key == CODED)
  {
    switch(tasto)
    {
      case RIGHT: eroe.comando(EST  ); break;
      case UP   : eroe.comando(NORD ); break;
      case LEFT : eroe.comando(OVEST); break;
      case DOWN : eroe.comando(SUD  ); break;
      // ................................
    }   
  }
  else
  {
    switch(tasto)
    {
      case TAB :            incLivello(+1);   caricaLivello(); break;
      case 'q' : case 'Q' : incLivello(-1);   caricaLivello(); break; 
      case 'c' : case 'C' : incCategoria(+1); caricaLivello(); break; 
      case 'v' : case 'V' : incCategoria(-1); caricaLivello(); break;  
      // .................................
    } 
  }
}

void incLivello(int dir)
{
  if(dir == +1)
  {
    numLivello++; 
    if(numLivello > maxLivello)
      incCategoria(+1);
  }
  else if(dir == -1)
  {
    numLivello--; 
    if(numLivello == 0)
      incCategoria(-1);
  }
}
void incCategoria(int dir)
{
  if(dir == +1)
  {
    numCategoria++;
    if(numCategoria == nomiCATEGORIE.length)
      numCategoria=0;
  }
  else if(dir == -1)
  {
    numCategoria--;
    if(numCategoria == -1)
      numCategoria=nomiCATEGORIE.length-1;
  }
  numLivello=1;
}

void fileToLivello()
{
  String upload[];
  do
  {
    upload=loadStrings(nomiCATEGORIE[numCategoria]+"/"+numLivello+".txt");
    if(upload != null)
    {
        for(int r=0; r < numR; r++)
        for(int c=0; c < numC; c++)
           livello[r][c]=upload[r].charAt(c);
    }
    else
        incLivello(+1);
  }
  while(upload == null);
}

void livelloToOggetti()
{
  for(int r=0; r < numR; r++)
  for(int c=0; c < numC; c++)
  {
      char oggetto=livello[r][c];

      if(oggetto==charIMMAGINI[iARRIVO]) 
      { 
        leBOMBE[r][c]=null;
        livello[r][c]=iARRIVO;
      }
      else if(oggetto==charIMMAGINI[iMURO]) 
      { 
        leBOMBE[r][c]=null;
        livello[r][c]=iMURO;
        muro.disegna(r, c);
      }
      else if(oggetto==charIMMAGINI[iGHIAIA]) 
      { 
        leBOMBE[r][c]=null;
        livello[r][c]=iGHIAIA;      
        ghiaia.disegna(r, c);
      }
      else if(oggetto==charIMMAGINI[EST]) 
      { 
        eroe=new Eroe(r, c);
        leBOMBE[r][c]=null; 
        livello[r][c]=iGHIAIA;
      }
      else if(oggetto==charIMMAGINI[iBOMBA]) 
      { 
        leBOMBE[r][c]=new Bomba(r, c, iBOMBA); 
        livello[r][c]=iGHIAIA;
      }
      else if(oggetto==charIMMAGINI[iBOMBA_]) 
      { 
        leBOMBE[r][c]=new Bomba(r, c, iBOMBA_); 
        livello[r][c]=iARRIVO;
      }
  }
}

void caricaLivello()
{
  fileToLivello();
  livelloToOggetti();
}

void aggiornaLivello()
{
  for(int r=0; r < numR; r++)
  for(int c=0; c < numC; c++)
  {
      char  oggetto=livello[r][c]; if(oggetto == iARRIVO) arrivo.disegna(r, c);
      Bomba bomba  =leBOMBE[r][c]; if(bomba   != null   ) bomba.disegna(); 
  }
  eroe.disegna();
}

void aggiorna(int r, int c)
{
  switch(livello[r][c])
  {
    case iGHIAIA: ghiaia.disegna(r,c); break;
    case iARRIVO: arrivo.disegna(r,c); break;
  }
}

class Muro   
{ 
  void disegna(int r, int c) { image(immagini[iMURO  ][0], COLONNE[c], RIGHE[r]); } 
}
class Ghiaia 
{ 
  void disegna(int r, int c) { image(immagini[iGHIAIA][0], COLONNE[c], RIGHE[r]); } 
}

class Arrivo
{
  int frame;

  Arrivo() { frame=0; }

  void disegna(int r, int c)     
  {
    ghiaia.disegna(r, c); 
    image(immagini[iARRIVO][frame], COLONNE[c], RIGHE[r]);      
    frame++;
    if(frame==numIMMAGINI[iARRIVO])
      frame=0;
  }
}

class Eroe
{
  int r, c;         
  int frame;
  int direzione;

  Eroe(int RIGA, int COLONNA)
  {
    r        =RIGA;
    c        =COLONNA;
    frame    =0;
    direzione=EST;
  }

  void disegna()     
  {
    aggiorna(r, c);
    image(immagini[direzione][frame], COLONNE[c], RIGHE[r]);      
    frame++;
    if(frame==numIMMAGINI[direzione])
      frame=0;
  }
  void comando(int dir)
  {
    if(dir != direzione)
    {
      direzione=dir;
    }
    else                
    {
      int newR=r, 
      newC=c; 
      switch(direzione)
      {
        case EST  : newC=c+1; if(newC == numC) newC=0;      break;
        case NORD : newR=r-1; if(newR == -1  ) newR=numR-1; break;
        case OVEST: newC=c-1; if(newC == -1  ) newC=numC-1; break;
        case SUD  : newR=r+1; if(newR == numR) newR=0;      break;
      }
      if(livello[newR][newC] != iMURO)
      {
        Bomba b=leBOMBE[newR][newC];     
        if(b == null)
        {                               
          aggiorna(r, c);
          r=newR;
          c=newC;
        }
        else 
          b.comando(direzione);
      }
    }
  }
}

class Bomba
{
  int r, c;
  int frame;
  int stato;

  Bomba(int RIGA, int COLONNA, int STATO)
  {
    r    =RIGA;
    c    =COLONNA;
    frame=0;
    stato=STATO;
  }

  void disegna()     
  {
    ghiaia.disegna(r,c);
    image(immagini[stato][frame], COLONNE[c], RIGHE[r]);      
    frame++;
    if(frame == numIMMAGINI[stato])
      frame=0;
  }

  void comando(int dir)
  {
    int newR=r;
    int newC=c;

    switch(dir)
    {
      case EST  : newC=c+1; if(newC == numC) newC=0;      break;
      case NORD : newR=r-1; if(newR == -1  ) newR=numR-1; break;
      case OVEST: newC=c-1; if(newC == -1  ) newC=numC-1; break;
      case SUD  : newR=r+1; if(newR == numR) newR=0;      break;    
    }
    char oggetto=livello[newR][newC];
    if(oggetto != iMURO)
    {
      if(leBOMBE[newR][newC] == null)
      {                
        leBOMBE[newR][newC]=this;
        leBOMBE[r][c]=null;
        aggiorna(r,c);
        r=newR;
        c=newC;
        if(oggetto == iARRIVO) stato=iBOMBA_;
        else                   stato=iBOMBA;
      }
    }
  }
}
